Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members

# SimpleKeyedTransformation< T > Class Template Reference

Inheritance diagram for SimpleKeyedTransformation< T >:

List of all members.

## Detailed Description

### template<class T>
class SimpleKeyedTransformation< T >

Definition at line 586 of file cryptlib.h.

## Public Types
enum | IV_Requirement { STRUCTURED_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
## Public Member Functions
void | ThrowIfInvalidKeyLength (unsigned int length)
virtual unsigned int | MinKeyLength () const =0
| returns smallest valid key length in bytes */
virtual unsigned int | MaxKeyLength () const =0
| returns largest valid key length in bytes */
virtual unsigned int | DefaultKeyLength () const =0
| returns default (recommended) key length in bytes */
virtual unsigned int | GetValidKeyLength (unsigned int n) const =0
| returns the smallest valid key length in bytes that is >= min(n, GetMaxKeyLength())
virtual bool | IsValidKeyLength (unsigned int n) const
| returns whether n is a valid key length
virtual void | SetKey (const byte *key, unsigned int length, const NameValuePairs &params=g_nullNameValuePairs)=0
| set or reset the key of this object
void | SetKeyWithRounds (const byte *key, unsigned int length, int rounds)
| calls SetKey() with an NameValuePairs object that just specifies "Rounds"
void | SetKeyWithIV (const byte *key, unsigned int length, const byte *iv)
| calls SetKey() with an NameValuePairs object that just specifies "IV"
virtual IV_Requirement | IVRequirement () const =0
| returns the minimal requirement for secure IVs
bool | IsResynchronizable () const
| returns whether this object can be resynchronized (i.e. supports initialization vectors)
bool | CanUseRandomIVs () const
| returns whether this object can use random IVs (in addition to ones returned by GetNextIV)
bool | CanUsePredictableIVs () const
| returns whether this object can use random but possibly predictable IVs (in addition to ones returned by GetNextIV)
bool | CanUseStructuredIVs () const
| returns whether this object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV)
virtual unsigned int | IVSize () const
| returns size of IVs used by this object
virtual void | Resynchronize (const byte *IV)
| resynchronize with an IV
virtual void | GetNextIV (byte *IV)
| get a secure IV for the next message
## Protected Member Functions
void | ThrowIfInvalidKeyLength (const Algorithm &algorithm, unsigned int length)
void | ThrowIfResynchronizable ()
void | ThrowIfInvalidIV (const byte *iv)
const byte * | GetIVAndThrowIfInvalid (const NameValuePairs &params)
void | AssertValidKeyLength (unsigned int length) const

## Member Function Documentation

virtual void SimpleKeyingInterface::SetKey | ( | const byte * | key,
|  | unsigned int | length,
|  | const NameValuePairs & | params = `g_nullNameValuePairs`
| ) | `[pure virtual, inherited]`

  | set or reset the key of this object Parameters:
  | params | is used to specify Rounds, BlockSize, etc
Implemented in CipherModeBase, HermeticHashFunctionMAC< T_Hash, T_Info >, HermeticHashFunctionMAC< PanamaHash< B > >, MessageAuthenticationCodeImpl< HMAC_Base, HMAC< T > >, MessageAuthenticationCodeImpl< MD5MAC_Base >, MessageAuthenticationCodeImpl< XMACC_Base< T > >, MessageAuthenticationCodeImpl< DMAC_Base< T > >, MessageAuthenticationCodeImpl< TTMAC_Base >, MessageAuthenticationCodeImpl< CBC_MAC_Base, CBC_MAC< T > >, SymmetricCipherFinal< MARC4_Base >, and SymmetricCipherFinal< ARC4_Base >. Referenced by SimpleKeyingInterface::SetKeyWithIV(), SimpleKeyingInterface::SetKeyWithRounds(), and BlockOrientedCipherModeBase::UncheckedSetKey().

bool SimpleKeyingInterface::IsResynchronizable | ( |  | ) | const`[inline, inherited]`

| returns whether this object can be resynchronized (i.e. supports initialization vectors) If this function returns true, and no IV is passed to SetKey() and CanUseStructuredIVs()==true, an IV of all 0's will be assumed. Definition at line 384 of file cryptlib.h. Referenced by SimpleKeyingInterface::ThrowIfInvalidIV(), SimpleKeyingInterface::ThrowIfResynchronizable(), and BlockOrientedCipherModeBase::UncheckedSetKey().

virtual void SimpleKeyingInterface::GetNextIV | ( | byte * | IV | ) | `[inline, virtual, inherited]`

| get a secure IV for the next message This method should be called after you finish encrypting one message and are ready to start the next one. After calling it, you must call SetKey() or Resynchronize() before using this object again. This method is not implemented on decryption objects. Reimplemented in CipherModeBase, CTR_ModePolicy, and XMACC_Base< T >. Definition at line 400 of file cryptlib.h.

The documentation for this class was generated from the following file:

- cryptlib.h